//Patriche Robert Cosmin 3Ain
/*Data in input una sequenza di lunghezza predeterminata di n numeri interi, inserirli in un vettore. 
Creare una prima versione che carica il vettore da destra a sinistra, e una seconda versione che carica il vettore da sinistra a destr*/

#include <iostream>
#include <vector>
using namespace std;

// Funzione per caricare un vettore da destra a sinistra
void caricaDaDestra(std::vector<int>& v, int n) {
    cout << "Inserisci " << n << " numeri interi (da destra a sinistra):" << endl;
    for (int i = n - 1; i >= 0; --i) {
        cout << "Elemento " << n - i << ": ";
        cin >> v[i];
    }
}

// Funzione per caricare un vettore da sinistra a destra
void caricaDaSinistra(std::vector<int>& v, int n) {
    cout << "Inserisci " << n << " numeri interi (da sinistra a destra):" << endl;
    for (int i = 0; i < n; ++i) {
        cout << "Elemento " << i + 1 << ": ";
        cin >> v[i];
    }
}

// Funzione per stampare il vettore
void stampaVettore(const std::vector<int>& v) {
    cout << "Contenuto del vettore: ";
    for (const int& elem : v) {
        cout << elem << " ";
    }
    cout << endl;
}

int main() {
    int n;
    cout << "Quanti numeri vuoi inserire? ";
    st:cin >> n;

    // Creazione del vettore
    vector<int> vettore(n);

    // Versione 1: Caricamento da destra a sinistra
    caricaDaDestra(vettore, n);
    stampaVettore(vettore);

    // Versione 2: Caricamento da sinistra a destra
    caricaDaSinistra(vettore, n);
    stampaVettore(vettore);

    return 0;
}
