#include <stdio.h>

// Funzione per calcolare la potenza
int potenza(int base, int esponente) {
    int risultato = 1;
    for (int i = 0; i < esponente; i++) {
        risultato *= base;
    }
    return risultato;
}

int main() {
    int b, e;
    
    // Richiedi all'utente di inserire la base b e l'esponente e
    printf("Inserisci la base (b): ");
    scanf("%d", &b);
    printf("Inserisci l'esponente (e): ");
    scanf("%d", &e);

    // Verifica che entrambi b ed e siano numeri interi positivi
    if (b < 0 || e < 0) {
        printf("La base e l'esponente devono essere numeri interi positivi.\n");
        return 1; // Termina il programma con un codice di errore
    }

    // Calcola e stampa la potenza
    int risultato = potenza(b, e);
    printf("%d elevato alla %d e' : %d\n", b, e, risultato);

    return 0;
}

