//Patriche Robert Cosmin
#include <iostream>
using namespace std;

int sommaCornice(int matrice[5][5], int n) {
    int somma = 0;

    // Sommare i bordi della cornice
    for (int i = 0; i < n; i++) {
        somma += matrice[0][i];           // Prima riga
        somma += matrice[n - 1][i];       // Ultima riga
        somma += matrice[i][0];           // Prima colonna
        somma += matrice[i][n - 1];       // Ultima colonna
    }

    // Rimuovere i doppioni (gli angoli)
    somma -= matrice[0][0];       // Angolo in alto a sinistra
    somma -= matrice[0][n - 1];   // Angolo in alto a destra
    somma -= matrice[n - 1][0];   // Angolo in basso a sinistra
    somma -= matrice[n - 1][n - 1]; // Angolo in basso a destra

    return somma;
}

int main() {
    int matrice[5][5] = {{1, 2, 3, 4, 5},
                         {6, 7, 8, 9, 10},
                         {11, 12, 13, 14, 15},
                         {16, 17, 18, 19, 20},
                         {21, 22, 23, 24, 25}};
    int somma = sommaCornice(matrice, 5);
    cout << "Somma della cornice: " << somma << endl;
    return 0;
}
